package com.usoft.sso.utils;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * SSO 配置
 *
 * @author: wangcanyi
 * @date: 2018-08-16 09:29
 **/
@Component
@ConfigurationProperties("sso")
public class SsoProperties {
	/**
	 * Application Number
	 */
	private String app = "";
	/**
	 * Login, decrypt, secret key
	 */
	private String secretKey = "";
	/**
	 * cookie is check user-agent property
	 */
	private boolean cookieBrowser = false;

	/**
	 * Application Number
	 *
	 * @return
	 */
	public String getApp() {
		return app;
	}

	/**
	 * @param app Application Number
	 */
	public void setApp(String app) {
		this.app = app;
	}

	/**
	 * Login, decrypt, secret key
	 *
	 * @return
	 */
	public String getSecretKey() {
		return secretKey;
	}

	/**
	 * @param secretKey Login, decrypt, secret key
	 */
	public void setSecretKey(String secretKey) {
		this.secretKey = secretKey;
	}

	/**
	 * cookie is check user-agent property
	 *
	 * @return
	 */
	public boolean isCookieBrowser() {
		return cookieBrowser;
	}

	/**
	 * @param cookieBrowser cookie is check user-agent property
	 */
	public void setCookieBrowser(boolean cookieBrowser) {
		this.cookieBrowser = cookieBrowser;
	}
}
